def kod_znaku(c):
  if c == '?':
    return 0
  return ord(c) - ord('a') + 1

def maska_znakow(s):
  res = 0
  for i in range(len(s)):
    res = (res << 5) | kod_znaku(s[i])
  res = (res << 5) | len(s)
  return res

def znak_z_kodu(kod):
  if kod == 0:
    return '?'
  return chr(kod - 1 + ord('a'))

def slowo_z_maski(maska):
  n = (maska & 31)
  maska = (maska >> 5)
  litery = []
  for i in range(n):
    litery.append(znak_z_kodu(maska & 31))
    maska = (maska >> 5)
  return ''.join(litery[::-1])

def kod_wzorca(c):
  if c == '?':
    return 0
  return 31

def licz_maske_wzorca(s):
  res = 0
  for i in range(len(s)):
    res = (res << 5) | kod_wzorca(s[i])
  res = (res << 5) | 31
  return res

def generuj_podmaski(maska):
  n = (maska & 31)
  def generuj(nowe, i, kawalek):
    if i == n + 1:
      yield nowe
      return
    fragment = (maska & kawalek)
    if fragment:
      yield from generuj(nowe | fragment, i + 1, kawalek << 5)
    yield from generuj(nowe, i + 1, kawalek << 5)
  return generuj(n, 1, 31 << 5)

def generuj_podmaski_limit(maska, limit):
  n = (maska & 31)
  def generuj(nowe, i, kawalek, lim):
    if i == n + 1:
      if lim == 0:
        yield nowe
      return
    fragment = (maska & kawalek)
    if fragment:
      yield from generuj(nowe | fragment, i + 1, kawalek << 5, lim - 1)
    yield from generuj(nowe, i + 1, kawalek << 5, lim)
  return generuj(n, 1, 31 << 5, limit)

def generuj_podmaski_limit_le(maska, limit):
  n = (maska & 31)
  def generuj(nowe, i, kawalek, lim):
    if i == n + 1:
      yield nowe
      return
    fragment = (maska & kawalek)
    if fragment and lim > 0:
      yield from generuj(nowe | fragment, i + 1, kawalek << 5, lim - 1)
    yield from generuj(nowe, i + 1, kawalek << 5, lim)
  return generuj(n, 1, 31 << 5, limit)

LIMIT = 6
LIMIT_MASKI = 3

podmaski = dict()
duze_podmaski = dict()

n = int(input())

for i in range(n):
  maska = maska_znakow(input())
  if (maska & 31) <= LIMIT:
    for podmaska in generuj_podmaski(maska):
      dane = podmaski.setdefault(podmaska, [0, 0])
      dane[0] += 1
      dane[1] = maska
  else:
    for podmaska in generuj_podmaski_limit_le(maska, LIMIT_MASKI):
      dane = duze_podmaski.setdefault(podmaska, [])
      dane.append(maska)
      dane = podmaski.setdefault(podmaska, [0, 0])
      dane[0] += 1
      dane[1] = maska

n = int(input())

for i in range(n):
  wzorzec = input()
  literki = len(wzorzec) - wzorzec.count('?')
  maska = maska_znakow(wzorzec)
  maska_wzorca = licz_maske_wzorca(wzorzec)
  if len(wzorzec) <= LIMIT:
    liczba, ktorekolwiek_slowo = podmaski.get(maska, [0, 0])
  elif literki <= LIMIT_MASKI:
    liczba, ktorekolwiek_slowo = podmaski.get(maska, [0, 0])
  else:
    lista = []
    for mas in generuj_podmaski_limit(maska, LIMIT_MASKI):
      dane = duze_podmaski.get(mas, [])
      if len(lista) == 0 or (len(dane) > 0 and len(dane) < len(lista)):
        lista = dane
    liczba = 0
    ktorekolwiek_slowo = 0
    for mas in lista:
      if (mas & maska_wzorca) == maska:
        liczba += 1
        ktorekolwiek_slowo = mas
  if liczba == 1:
    print(slowo_z_maski(ktorekolwiek_slowo))
  else:
    print(liczba)
